<?php
// Convert a path name and a project identifier to a System V IPC key
$key1 = ftok(dirname(__FILE__) . '/ex1-token.php', 'A'); 
$key2 = ftok(dirname(__FILE__) . '/ex1-token.php', 'B'); 

// Creating a message queue with a key, we need to use an integer value.
$queue1 = msg_get_queue($key1);
$queue2 = msg_get_queue($key2);

// Loop through all, read messages are removed from the queue.
// Here we find a constant MSG_IPC_NOWAIT, without it all will hang forever.
$counter_file = dirname(__FILE__) . "/cnt.txt";
echo "*** qsys-f starting\n";
while (1) {
    if( msg_receive($queue1, 0, $msgtype, 4096, $message, false, MSG_IPC_NOWAIT) ) {
        $cnt_str = get_cnt();
        echo "msgtype: {$msgtype}, message: {$message}, return {$cnt_str}\n";
        msg_send($queue2, $msgtype, $cnt_str );

    }
}
/*
  get counter value
*/
function get_cnt() {
    global $counter_file;
    $fp = fopen($counter_file, "r+");
    $val = (int)fgets($fp);
    $val += 1;
    rewind($fp);
    fwrite($fp, strval($val));
    fclose($fp);
    return sprintf("%06d", $val);
}
?>
