<?php
require(dirname(__FILE__) . '/db.php');
$dbconfig=array(
        'host' => 'localhost',
        'dbname' => 'mydb',
        'username' => 'myuser',
        'password' => '12345678',
        'charset' => 'utf8',
);
$tblname = "a0006";

// Convert a path name and a project identifier to a System V IPC key
$key1 = ftok(dirname(__FILE__) . '/ex1-token.php', 'A'); 
$key2 = ftok(dirname(__FILE__) . '/ex1-token.php', 'B'); 

// Creating a message queue with a key, we need to use an integer value.
$queue1 = msg_get_queue($key1);
$queue2 = msg_get_queue($key2);

// Loop through all, read messages are removed from the queue.
// Here we find a constant MSG_IPC_NOWAIT, without it all will hang forever.
echo "*** qsys-d starting\n";
while (1) {
    if( msg_receive($queue1, 0, $msgtype, 4096, $message, false, MSG_IPC_NOWAIT) ) {
        $cnt_str = get_cnt();
        echo "msgtype: {$msgtype}, message: {$message}, return {$cnt_str}\n";
        msg_send($queue2, $msgtype, $cnt_str );
    }
}
/*
  get counter value
*/
function get_cnt() {
    global $dbconfig, $tblname;
    $conn = new DB($dbconfig);
    $stmt = $conn->fetch("SELECT val FROM {$tblname}");
    if(!$stmt) { echo "fetch() error {$conn->error} \n"; return "_ERROR"; }
    $val = $stmt['val'];
    $val += 1;
    if(!$conn->execute("UPDATE {$tblname} SET val=?", [$val])) {
        echo "execute() error {$conn->error}\n";
        return "_ERROR";
    }
    return sprintf("%06d", $val);
}
?>
