<?php
error_reporting(E_ERROR & ~E_NOTICE);
$func=$argv[1];	// start | stop	| stat
$maxcnt=(int)$argv[2]; // the number of client programs to be generated
/* $argv[3], for example,
 http://hr5:90/wpp/exams/a0006/ex1-token.php
 http://hr5:90/wpp/exams/a0006/ex2-token-d.php
 http://hr5:90/wpp/exams/a0006/ex2-token-f.php
*/
$url = $argv[3];

switch ($func) {
    default:
        echo "INVALID ARGUMENT\n";
        break;
    case "start":  
        actionStart($maxcnt);
        break;
    case "stop":  
        actionStop();
        break;
    case "stat":  
        actionStat();
        break;
}	
	
function actionStart($n) {
    global $url;
    /* remove history data */
    exec("rm sendlog/*");
    exec("rm recvlog/*");
    $err_cnt = 0;
    $prev_pid = 0;
    for ($i = 1; $i <= $n; $i++) {
        $cmd1="php simcli.php {$i} {$url}";
        exec($cmd1 . " > /dev/null &");
        usleep(1000); 
    }
    $beginning = date("H:i:s");
    while(1) {
        unset($out);
        $chk1="ps aux | grep 'php simcli.php' | grep -v grep | awk '{ print $2 }' ";
        exec($chk1, $out);
        //echo date("i:s") . " concurrent php simcli.php is " . count($out) . PHP_EOL;
        if(count($out) == 0) break;
        usleep(1000); 
    }
    echo "Duration: {$beginning} to " . date("H:i:s") . "\n";
}

function actionStop() {
	unset($out);
	$chk1="ps aux | grep 'php simcli.php' | grep -v grep | awk '{ print $2 }' ";
	exec($chk1, $out);
	foreach($out as $pid) {
		exec('kill ' . $pid);
		echo "killing " . $pid . PHP_EOL;
	}
        exec("rm sendlog/*");
        exec("rm recvlog/*");
}

function actionStat() {
	$folder='sendlog/';
	$files = glob($folder . '*', GLOB_MARK);
	$cnt = 0;
	foreach ($files as $file) {
		unset($out);
		exec("cat " . $file . " | wc -l", $out);
		if (isset($out[0])) $cnt += (int)$out[0];
	}            
	echo 'sendlog count: ' . $cnt . PHP_EOL;

	$folder='recvlog/';
	$files = glob($folder . '*', GLOB_MARK);
        $stat = (float)0;
        $cnt = 0;
        $elapsed_cnt = 0;
        $timeout_cnt = 0;
	foreach ($files as $file) {
                $fp = fopen($file, "r");
                while(!feof($fp)) {
                        $ary = explode(' ', fgets($fp));
                        if($ary[0] == 'elapsed') {
                                $stat += (float)$ary[1];
                                $elapsed_cnt += 1;
                        }
                        if($ary[0] == 'timeout') {
                                $timeout_cnt += 1;
                        }
                        $cnt += 1;
                }
                $cnt -= 1;
        }
        echo 'recvlog count: ' . $cnt . PHP_EOL;
        echo 'elapsed count: ' . $elapsed_cnt . PHP_EOL;
        echo 'timeout count: ' . $timeout_cnt . PHP_EOL;
        echo 'elapsed average: ' . sprintf("%.4f", $stat / $elapsed_cnt) . PHP_EOL;
}

?>
